import * as lambda from 'aws-cdk-lib/aws-lambda';
import * as lambdaNode from 'aws-cdk-lib/aws-lambda-nodejs';
import { Construct } from 'constructs';
import * as lambda_powertools from './lambda-powertools';
import { BaseTagProps } from '../../common/utils';
export interface FunctionProps extends lambda.FunctionProps {
    readonly stage: string;
    readonly withBaseEnvironment?: boolean;
    readonly withBaseTags?: boolean;
    readonly baseTagsValues?: BaseTagProps;
    readonly baseEnvironmentValues?: BaseTagProps;
}
export interface FunctionNodeProps extends lambdaNode.NodejsFunctionProps {
    readonly stage: string;
    readonly withBaseEnvironment?: boolean;
    readonly withBaseTags?: boolean;
    readonly baseTagsValues?: BaseTagProps;
    readonly baseEnvironmentValues?: BaseTagProps;
}
export declare function addBaseEnvironment(lambdaFunction: lambda.Function, stage: string, props?: BaseTagProps): void;
export declare class Function extends lambda.Function {
    readonly stage: string;
    constructor(scope: Construct, id: string, props: FunctionProps);
    addBaseTags(values?: BaseTagProps): void;
    addBaseEnvironment(values?: BaseTagProps): void;
    addPowerToolsLayer(scope: Construct, lambdaPowerToolsLayerName: lambda_powertools.LambdaPowerToolsLayerName, lambdaPowerToolsLayerAccountId: lambda_powertools.LambdaPowerToolsLayerAccountId, lambdaPowerToolsLayerVersion: number, setPowertoolsDev?: boolean, setLogLevel?: string): void;
}
export declare class FunctionNode extends lambdaNode.NodejsFunction {
    readonly stage: string;
    constructor(scope: Construct, id: string, { runtime, architecture, ...props }: FunctionNodeProps);
    addBaseTags(values?: BaseTagProps): void;
    addBaseEnvironment(values?: BaseTagProps): void;
    addPowerToolsLayer(scope: Construct, lambdaPowerToolsLayerName: lambda_powertools.LambdaPowerToolsLayerName, lambdaPowerToolsLayerAccountId: lambda_powertools.LambdaPowerToolsLayerAccountId, lambdaPowerToolsLayerVersion: number, setPowertoolsDev?: boolean, setLogLevel?: string): void;
}
