import * as lambda from 'aws-cdk-lib/aws-lambda';
import * as lambdaNode from 'aws-cdk-lib/aws-lambda-nodejs';
import { Construct } from 'constructs';
import { Function, FunctionNode } from './lambda-functions';
export declare enum LambdaPowerToolsLayerAccountId {
    PYTHON = "017000801446",
    TYPESCRIPT = "094274105915"
}
export declare enum LambdaPowerToolsLayerName {
    PYTHON_ARM = "AWSLambdaPowertoolsPythonV2-Arm64",
    PYTHON_X86 = "AWSLambdaPowertoolsPythonV2",
    TYPESCRIPT = "AWSLambdaPowertoolsTypeScript"
}
export interface ILambdaPowerToolsProps {
    readonly lambdaFunction: lambda.Function | lambdaNode.NodejsFunction | Function | FunctionNode;
    readonly lambdaPowerToolsLayerName: LambdaPowerToolsLayerName;
    readonly lambdaPowerToolsLayerAccountId: LambdaPowerToolsLayerAccountId;
    readonly lambdaPowerToolsLayerVersion: number;
    readonly setPowertoolsDev?: boolean;
    readonly setLogLevel?: string;
}
export declare function getLamdaPowerToolsLayer(scope: Construct, functionName: string, layerName: LambdaPowerToolsLayerName, layerVersion: number, layerAccountId: LambdaPowerToolsLayerAccountId, region: string): lambda.ILayerVersion;
export declare function addLamdaPowerToolsLayer(scope: Construct, props: ILambdaPowerToolsProps): void;
