import * as lambda from 'aws-cdk-lib/aws-lambda';
import { Construct } from 'constructs';
import { Function, FunctionNode, FunctionProps, FunctionNodeProps } from './lambda-functions';
export declare const NEW_RELIC_LAYERS_ACCOUNT_ID = "451483290750";
export interface FunctionNewRelicProps extends FunctionProps {
    readonly newRelicLayerName: string;
    readonly newRelicLayerVersion: number;
    readonly newRelicAccountId: string;
    readonly newRelicwithExtensionSendLogs?: boolean;
    readonly disableNewRelic?: boolean;
}
export interface FunctionNodeNewRelicProps extends FunctionNodeProps {
    readonly newRelicLayerName: string;
    readonly newRelicLayerVersion: number;
    readonly newRelicAccountId: string;
    readonly newRelicwithExtensionSendLogs?: boolean;
    readonly disableNewRelic?: boolean;
}
export interface NewRelicLayerProps {
    readonly handler: string;
    readonly newRelicLayerName: string;
    readonly newRelicLayerVersion: number;
    readonly newRelicAccountId: string;
    readonly newRelicwithExtensionSendLogs?: boolean;
}
export declare function getNewRelicLayer(scope: Construct, functionName: string, layerName: string, layerVersion: number, region: string): lambda.ILayerVersion;
export declare function addNewRelicLayer(scope: Construct, lambdaFunction: lambda.Function, props: NewRelicLayerProps): void;
export declare class NewRelicFunction extends Function {
    constructor(scope: Construct, id: string, props: FunctionNewRelicProps);
    addNewRelicLayer(scope: Construct, props: NewRelicLayerProps): void;
}
export declare class NewRelicFunctionNode extends FunctionNode {
    constructor(scope: Construct, id: string, props: FunctionNodeNewRelicProps);
    addNewRelicLayer(scope: Construct, props: NewRelicLayerProps): void;
}
